OpenVDB 5.1.0

Public Types | Public Member Functions | Friends | List of all members
VolumeHDDA< TreeT, RayT, ChildNodeLevel > Class Template Reference

Helper class that implements Hierarchical Digital Differential Analyzers for ray intersections against a generic volume. More...

`#include <DDA.h>`

## Public Types
typedef TreeT::RootNodeType::NodeChainType | ChainT
typedef boost::mpl::at< ChainT, boost::mpl::int_< ChildNodeLevel > >::type | NodeT
typedef RayT::TimeSpan | TimeSpanT

## Public Member Functions
| VolumeHDDA ()
template<typename AccessorT >
TimeSpanT | march (RayT &ray, AccessorT &acc)
template<typename AccessorT , typename ListT >
void | hits (RayT &ray, AccessorT &acc, ListT &times)

## Friends
class | VolumeHDDA< TreeT, RayT, ChildNodeLevel+1 >

## Detailed Description

### template<typename TreeT, typename RayT, int ChildNodeLevel>
class openvdb::v5_1::math::VolumeHDDA< TreeT, RayT, ChildNodeLevel >

Helper class that implements Hierarchical Digital Differential Analyzers for ray intersections against a generic volume.

The template argument ChildNodeLevel specifies the entry upper node level used for the hierarchical ray-marching. The final lowest level is always the leaf node level, i.e. not the voxel level!

## Member Typedef Documentation

## ◆ ChainT

typedef TreeT::RootNodeType::NodeChainType ChainT

## ◆ NodeT

typedef boost::mpl::at<ChainT, boost::mpl::int_<ChildNodeLevel> >::type NodeT

## ◆ TimeSpanT

typedef RayT::TimeSpan TimeSpanT

## Constructor & Destructor Documentation

## ◆ VolumeHDDA()

VolumeHDDA | ( |  | ) |
| inline

## Member Function Documentation

## ◆ hits()

void hits | ( | RayT & | ray,
|  | AccessorT & | acc,
|  | ListT & | times
| ) |  |
| inline

ListType is a list of RayType::TimeSpan and is required to have the two methods: clear() and push_back(). Thus, it could be std::vector<typename RayType::TimeSpan> or std::deque<typename RayType::TimeSpan>.

## ◆ march()

TimeSpanT march | ( | RayT & | ray,
|  | AccessorT & | acc
| ) |  |
| inline

## Friends And Related Function Documentation

## ◆ VolumeHDDA< TreeT, RayT, ChildNodeLevel+1 >

friend class VolumeHDDA< TreeT, RayT, ChildNodeLevel+1 >
| friend

The documentation for this class was generated from the following file:

- DDA.h